#!/bin/bash
#
# Subject: ヒアドキュメント、ヒアストリング

# Hear Document
a="定義済み変数"
cat << EOHD
ここは、ヒアドキュメント内
変数は有効 $a
例えば、未定義変数もこのように ${b:-"未定義ならデフォルト値"}
EOHD
echo "a=$a"
echo "b=$b"

cat << "EOHD"
ここは、終了文字列を"で括ったヒアドキュメント内
変数展開は無効 $a
例えば、未定義変数もこのように ${b:-"未定義ならデフォルト値"} しても無駄
EOHD

# Hear String
echo "1+2" | bc  # これを、ヒアストリングを使えば、次のように書ける
bc <<<"1+2"
