#!/bin/bash
#
# Subject: setで位置パラメータに変数展開、

str="abc def ghi"
echo "str=$str"
echo 'set $str ' "# -オプションで、文字列を空白文字で分割して位置パラメータにセット"
set - $str
echo "\$1=$1"
echo "\$2=$2"
echo "\$3=$3"
echo

str='globbing * abc'
echo "str=$str"
echo 'set - $str ' "# 分割対象の文字列中に、Glob文字*など）があると、ファイル名が展開されてしまう"
set - $str
echo "\$1=$1"
echo "\$2=$2"
echo "\$3=$3"
echo
echo 'set -f ' "# オプションでglobbingを抑止"
set -f
echo 'set - $str'
set - $str
echo "\$1=$1"
echo "\$2=$2"
echo

echo 'set +f ' "# globbingを再開"
set +f
echo 'set - $str'
set - $str
echo "\$1=$1"
echo "\$2=$2"
echo

echo 'set -o noglob と set +o noglob は -f/+f に相当 # 以下同じ意味'
set -o noglob
set - $str
echo $1
echo $2
echo

set +o noglob
set - $str
echo $1
echo $2

